/*
 * smapiTest.java
 * Created on June 14, 2005, 11:05 AM
 */
package live.smapi;

import java.util.LinkedList;
import java.util.ListIterator;
import live.zvmtasks.ZVMTasks;

/**
 *
 * @author Jason J. Herne
 */
public class smapiTest
{
    
    /** Creates a new instance of smapiTest */
    public static void main(String[] args)
	throws Exception
    {
	System.out.println("arg 0 is " + args[0]);
	SMAPI_Interface smapi = new SMAPI_Interface("9.60.9.216",  44444, "VSMSTEVE",  "SS4VSM");
	ZVMTasks t = new ZVMTasks("9.60.9.216", 44444,  "VSMSTEVE", "SS4VSM");
	
	String arg0 = args[0];
	
	
	if(arg0.equals("nlnssq"))
	{
	    System.out.println("Querying namelist for access to NSS segfoo.");
	    LinkedList lst = smapi.nameListQuery("LIVESEG_" +
		    ""+ args[1]);
	    printList(lst);
	    return;	    
	}
	
//	if(arg0.equals("lnssq"))
//	{
//	    System.out.println("Querying namelist ALIVE_ALL for access to NSS segfoo.");
//	    LinkedList lst = smapi.sharedStorageQueryAccessNL("ALIVE_ALL", "SEGFOO");
//	    printList(lst);
//	    return;	    
//	}
	if(arg0.equals("lmake"))
	{
	    LinkedList guests = smapi.imageNameQuery(); 
	    
	    System.out.println("Adding " + guests.size() + "guest to namelist.");
	    
	    ListIterator itr = guests.listIterator();
	    while(itr.hasNext())
	    {
		String guestName = (String)itr.next();
		System.out.println(guestName);
		smapi.nameListAdd("ALIVE_ALL", guestName);
	    }
	    return;
	    
	}
	if(arg0.equals("dcopy"))
	{
	 smapi.imageDiskCopyDM("WATER16", "307", "MAINT", "191", "AUTOG", "MW", "&", "&", "&");
	 return;
	}
	if(arg0.equals("nssaccq"))
	{
	    String segName = args[1];
	    LinkedList guests = smapi.imageNameQuery(); 
	    
	    System.out.println("Querying access for segment " + segName + ".");
	    System.out.println("There are " + guests.size() + " guests to query.");
	    
	    ListIterator itr = guests.listIterator();
	    while(itr.hasNext())
	    {
		String guestName = (String)itr.next();
		LinkedList x = smapi.imageQuery(guestName);
		System.out.println((String)x.getFirst());
	    }
	    
	    
	    
	    smapi.sharedStorageQueryAccess("maint",  "segfoo");
	    return;
	}
	if(arg0.equals("nssq"))
	{
	    //smapi.sharedStorageAddAccess("MAINT", "SEGFOO");
	    smapi.sharedStorageQueryAccess("vsmsteve",  "segfoo");
	    return;
	}
	if(arg0.equals("rseg"))
	{
	    int numTimesToRun = Integer.parseInt(args[1]);
	    smapi.sharedStorageAddAccess("MAINT", "SEGFOO");
	    //System.out.println("access added");
	    for(int i=0; i < numTimesToRun; i++)
	    {
		smapi.sharedStorageRemoveAccess("MAINT", "SEGFOO");
		System.out.println("access removed.");
	    }
	    
	    return;
	    
	}
	if(arg0.equals("dcss1"))
	{
	    String range = smapi.sharedStorageFindPageRange("1", "MAINT");
	    System.out.println("range is: _" + range + "_");
	    return;
	}
	if(arg0.equals("dcss2"))
	{
	    String segName = args[1];
	    String range = smapi.sharedStorageFindPageRange("1", "MAINT");
	    smapi.sharedStorageCreate("maint", "segfoo", range, "EN");
	    System.out.println("range is: _" + range + "_");
	    System.out.println("Created shared seg " + args[1]);
	    return;
	}
	if(arg0.equals("dcss3"))
	{
	    String segName = args[1];
	    //smapi.sharedStorageAddAccess("VSMSTEVE", args[1]);
	    System.out.println("accessing seg " + args[1]);
	    smapi.sharedStorageDelete("VSMSTEVE", args[1]);
	    System.out.println("Deleted shared seg " + args[1]);
	    return;
	}
	if(arg0.equals("dcss4"))
	{
	    String segName = args[1];
	    smapi.sharedStorageAddAccess("MAINT", args[1]);
	    System.out.println("access add for seg " + args[1]);
	    return;
	}
	if(arg0.equals("dcss5"))
	{
	    String segName = args[1];
	    printList(smapi.sharedStorageQuery());
	    
	    return;
	}
	
	
	if(arg0.equals("link"))
	{
	    //smapi.imageDiskShare("maint", "122", "operator", "1919", "rr", "");
	    //smapi.imageDiskUnshare("maint", "191", "operator", "1913");
	    smapi.imageDiskUnshareDM("operator", "1919", "maint", "122");
	    
	    return;
	}
	if(arg0.equals("vdel"))
	{		
	    
	    System.out.println("vsw del....");
	    smapi.virtualSwitchDelete(args[1]);
	    return;
	}
	if(arg0.equals("vdet"))
	{
	    
	    System.out.println("vsw deT....");
	    smapi.virtualSwitchDetatch(args[1], args[2]);
	    return;
	}
	if(arg0.equals("iqn"))
	{
	    for(int i=0; i < Integer.parseInt(args[1]); i++)
	    {
		System.out.println("image query.... #" + i);
		LinkedList lst = smapi.imageQuery("AVSVM");
		
		ListIterator itr = lst.listIterator();
		while(itr.hasNext())
		{
		    System.out.println((String)itr.next());
		}
	    }
	    
	    return;
	}
	if(arg0.equals("iq"))
	{
	    
	    
	    System.out.println("image query.... #" + args[1]);
	    LinkedList lst = smapi.imageQuery(args[1]);

	    ListIterator itr = lst.listIterator();
	    while(itr.hasNext())
	    {
		System.out.println((String)itr.next());
	    }

	    return;
	}
	
	if(arg0.equals("null"))
	{
	    for(int i=0; i < Integer.parseInt(args[1]); i++)
	    {
		System.out.println("null.... #" + i);
		smapi.nullRequest();
	    }
	    
	    return;
	}
	
	if(Integer.parseInt(args[0]) == 0)
	{
	 smapi.nullRequest();   
	}
	else
	{
	    int i=0;
	    int end = Integer.parseInt(args[0]);
	    while(i != end)
	    {
		System.out.println("creating.... #" + i);
		t.createGuest("MRT", "pass", "1G", "64G", ZVMTasks.PROFILE_SUPER);
		System.out.println("deleting.... #" + i);
		t.deleteImage("MRT");
		i++;
	    }
	}

	
	
	
	//smapi.imageQuery("OPERATOR");
	//ListIterator itr = lst.listIterator();
	//while(itr.hasNext())
	//{
	//    System.out.println((String)itr.next());
	//}
	
	//smapi.ImageActivate("TESTLIST");
	
	/*
	LinkedList lst = smapi.imageQuery("OPERATOR");
	ListIterator itr = lst.listIterator();
	while(itr.hasNext())
	{
	    System.out.println((String)itr.next());
	}
	*/

    }
    
    public static void printList(LinkedList lst)
    {
	ListIterator itr = lst.listIterator();
	while(itr.hasNext())
	{
	    System.out.println((String)itr.next());
	}
    }
    
    
}
